const fs = require('fs');
const path = require('path');

exports.uploadVideo = async (request, reply) => {
    const { callid } = request.params;
    const { file, type } = request.payload;

    console.log('Recebendo arquivo de video', callid, type);

    const date = new Date();
    const dir = `/gravacoes/Videos/${date.getFullYear()}/${date.getMonth() + 1}/${date.getDate()}/${callid}`;
    if (!fs.existsSync(path.resolve(dir))) {
        fs.mkdirSync(path.resolve(dir), { recursive: true });
    }
    try {
        const newName = file.hapi.filename;
        // const newName = name.substring(0, name.lastIndexOf(".")) + uuid() + name.substring(name.lastIndexOf("."));
        const file_path = path.resolve(dir, newName);
        const writeStream = fs.createWriteStream(file_path);
        writeStream.on("error", function (err) {
            fs.unlinkSync(file_path);
            resolve({ ...file, error: err, size: file.bytes });
        });
        file.pipe(writeStream);
        file.on("end", async function (err) {
            if (err) {
                fs.unlinkSync(file_path);
                resolve({ ...file, error: err, size: file.bytes });
            } else {
                reply({ path: file_path, size: file.bytes });
            }
        });
        
    } catch (e) {
        reply(Boom.badData(e));
    }
}