'use strict'
const Joi = require('joi');
const handlers = require('./handlers');

module.exports = [
    {
    method: "POST",
    path: "/api/v4/videos/{callid}",
    handler: handlers.uploadVideo,
    config: {
      description: "Envia uma gravação de video",
      tags: ["api", "Video"],
      auth: {
        strategy: "bearer",
        scope: ["app.cdrfilas", "admin"],
      },
      payload: {
        output: "stream",
        allow: "multipart/form-data",
        maxBytes: 600 * 1024 * 1024, // 600mb
        parse: true,
      },
      validate: {
        params: {
          callid: Joi.string().required()
        },
        payload: {
          file: Joi.any().required().description("Arquivo"),
          type: Joi.string().required().description("Tipo de arquivo"),
        },
      },
    },
  },
]