/**
 * Pega o agente que está a mais tempo sem atender para realizar o atendimento
 * @param {*} fila Objeto fila do Ami
 * @returns
 */
let ultimoAgenteSelecionado = ''
const state_agentes = [] 
module.exports = (fila) => {
    try {
      // Pega agentes disponíveis
      let agentes;
      if ([1, 9].includes(fila.queue_type)) {
        agentes = fila.agentes.filter((a) => a.pausa === 0 && a.status === 1);
      } else {
        agentes = fila.agentes.filter((a) => a.pausa === 0);
      }
  
      if (agentes && agentes.length > 0) {
        // Verifica se existe algum agente sem DataUltimoAtendimento e o seleciona

        function encontrarAgenteMaisTempoSemAtender(agentes) {
            let agenteMaisAntigo = null;
            let dataMaisAntiga = null;
            agentes.forEach((agente) => {
                const found = state_agentes.find((a) => a.nome === agente.nome);
                if (!found) {
                  state_agentes.push({ nome: agente.nome, ultimaTentativa: new Date(0) });
                }
            });
            let agentesDisponiveis = agentes.filter(
                (agente) => agente.max_chat_atende > agente.atendimento_ativo.length && agente.nome !== ultimoAgenteSelecionado
            );

            if (agentes.length === 1) {
                ultimoAgenteSelecionado = ''
                agentesDisponiveis = agentes.filter(
                    (agente) => agente.atendimento_ativo.length < agente.max_chat_atende
                  );
            }
            if (agentesDisponiveis.length === 0 ) return null
              
            agentesDisponiveis.forEach((agente) => {
                const stateAgente = state_agentes.find((a) => a.nome === agente.nome);
                if (!dataMaisAntiga || new Date(stateAgente.ultimaTentativa) < dataMaisAntiga) {
                  dataMaisAntiga = new Date(stateAgente.ultimaTentativa);
                  agenteMaisAntigo = agente;
                }
              });
      
              return agenteMaisAntigo;
            }
          
          const agenteEscolhido = encontrarAgenteMaisTempoSemAtender(agentes);
          if (agenteEscolhido) {
            const stateAgente = state_agentes.find((a) => a.nome === agenteEscolhido.nome);
            stateAgente.ultimaTentativa = new Date();
    
            ultimoAgenteSelecionado = agenteEscolhido.nome;
            return agenteEscolhido;
          } else {
            ultimoAgenteSelecionado = '';
            return null;
          }    
      }
    } catch (error) {
      console.error("Erro ao tentar buscar agente por balanceamento", error);
    }
  };
  